/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Octets
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.activity.award.RewardMgr
 *  fire.pb.battle.pvp.EPvPType
 *  fire.pb.battle.pvp.PvPHelper
 *  fire.pb.circletask.PVPScoreAwardConfig
 *  fire.pb.item.Pack
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.MessageUtil
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xtable.Locks
 *  xtable.Properties
 */
package fire.pb.battle.pvp1;

import com.locojoy.base.Octets;
import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.activity.award.RewardMgr;
import fire.pb.battle.pvp.EPvPType;
import fire.pb.battle.pvp.PvPHelper;
import fire.pb.battle.pvp1.PvP1RaceProxy;
import fire.pb.battle.pvp1.PvP1RoleProxy;
import fire.pb.battle.pvp1.SPvP1BattleInfo;
import fire.pb.circletask.PVPScoreAwardConfig;
import fire.pb.item.Pack;
import fire.pb.talk.MessageMgr;
import fire.pb.util.MessageUtil;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Set;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xtable.Locks;
import xtable.Properties;

public class PPvP1ProcessBattleResult
extends Procedure {
    public final int gradeId;
    public final long winnerId;
    public final long loserId;
    public final boolean loserRunaway;

    public PPvP1ProcessBattleResult(int gradeId, long winnerId, long loserId, boolean loserRunaway) {
        this.gradeId = gradeId;
        this.winnerId = winnerId;
        this.loserId = loserId;
        this.loserRunaway = loserRunaway;
    }

    public boolean process() {
        PvP1RaceProxy race = PvP1RaceProxy.getPvP1RaceProxy(this.gradeId);
        if (race.getXRace() == null) {
            return false;
        }
        HashSet<Long> roleids = new HashSet<Long>();
        roleids.add(this.winnerId);
        roleids.add(this.loserId);
        Set<Long> broadcastset = race.getBroadcastRoles(new HashSet<Long>());
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, roleids));
        PvP1RoleProxy winner = PvP1RoleProxy.getPvP1RoleProxy(this.winnerId, false);
        PvP1RoleProxy loser = PvP1RoleProxy.getPvP1RoleProxy(this.loserId, false);
        int winnerScoreLv = winner.getScoreLevel();
        int loserScoreLv = loser.getScoreLevel();
        int winScore = this.getWinScore(winnerScoreLv, loserScoreLv);
        int loseScore = this.getLoseScore(winnerScoreLv, loserScoreLv);
        if (this.loserRunaway) {
            loseScore = 0;
        }
        this.processBattleWinType(race, winner, winScore, loser, loseScore, broadcastset);
        return true;
    }

    private void processBattleWinType(PvP1RaceProxy race, PvP1RoleProxy winner, int winScore, PvP1RoleProxy loser, int loseScore, Set<Long> broadcastSet) {
        Pack bag;
        int winnerLevel = Properties.selectLevel((Long)winner.getRoleId());
        int loserLevel = Properties.selectLevel((Long)loser.getRoleId());
        int winAwardId = PvPHelper.getAwardIdByRoleLevel((EPvPType)EPvPType.PVP1, (int)winnerLevel, (boolean)true, (int)0);
        int loseAwardId = PvPHelper.getAwardIdByRoleLevel((EPvPType)EPvPType.PVP1, (int)loserLevel, (boolean)false, (int)0);
        this.awardAndSendMsg(winner, winAwardId, loser, loseAwardId, broadcastSet, winner.getContinueWinNum() + 1, loser.getContinueWinNum());
        int winRongYu = winScore;
        int loseRongYu = loseScore;
        if (winner.getBattleNum() + 1 > 10) {
            winScore = 0;
        }
        if (loser.getBattleNum() + 1 > 10) {
            loseScore = 0;
        }
        if (winScore > 0) {
            winner.addScore(winScore, false);
        }
        if (loseScore > 0) {
            loser.addScore(loseScore, false);
        }
        if (winRongYu > 0) {
            bag = new Pack(this.winnerId, false);
            bag.addSysCurrency((long)winRongYu, 5, "PVP1Winer", YYLoggerTuJingEnum.tujing_Value_PVP1, 0);
            MessageUtil.pSendAddOrRemoveCurrency((long)this.winnerId, (long)winRongYu, (int)5);
        }
        if (loseRongYu > 0) {
            bag = new Pack(this.loserId, false);
            bag.addSysCurrency((long)loseRongYu, 5, "PVP1Loser", YYLoggerTuJingEnum.tujing_Value_PVP1, 0);
            MessageUtil.pSendAddOrRemoveCurrency((long)this.loserId, (long)loseRongYu, (int)5);
        }
        winner.onBattleEnd(true, this.loserId, winScore, race);
        loser.onBattleEnd(false, this.winnerId, loseScore, race);
    }

    private void awardAndSendMsg(PvP1RoleProxy winner, int winAward, PvP1RoleProxy loser, int loseAward, Set<Long> broadcastSet, int continueWinNum, int endContinueWinNum) {
        String winnername = Properties.selectRolename((Long)winner.getRoleId());
        String losername = Properties.selectRolename((Long)loser.getRoleId());
        continueWinNum = Math.min(99, continueWinNum);
        HashMap<String, Integer> params = new HashMap<String, Integer>();
        params.put("PVPCnt", continueWinNum);
        params.put("PVPTargetCnt", endContinueWinNum);
        if (winAward > 0) {
            if (winner.getBattleNum() + 1 <= 10) {
                RewardMgr.getInstance().distributeAllAward(winner.getRoleId(), winAward, params, YYLoggerTuJingEnum.tujing_Value_PVP1, 0, 4002, "PVP1胜利");
            }
            this.sendRaceBattleInfo(winner.getRoleId(), 160387, losername, winner.getBattleNum() + 1);
        }
        if (loseAward > 0) {
            if (loser.getBattleNum() + 1 <= 10) {
                RewardMgr.getInstance().distributeAllAward(loser.getRoleId(), loseAward, params, YYLoggerTuJingEnum.tujing_Value_PVP1, 0, 4002, "PVP1失败");
            }
            this.sendRaceBattleInfo(loser.getRoleId(), 160388, winnername, loser.getBattleNum() + 1);
        }
        if (continueWinNum >= 5) {
            this.sendRaceBattleInfo(broadcastSet, 160389, winnername, continueWinNum);
        }
        if (endContinueWinNum >= 5) {
            this.sendRaceBattleInfo(broadcastSet, 160390, winnername, losername, endContinueWinNum);
        }
    }

    private void sendRaceBattleInfo(Set<Long> broadcastSet, int msgId, Object ... params) {
        if (msgId <= 0) {
            return;
        }
        LinkedList<Octets> octetses = new LinkedList<Octets>();
        if (params != null) {
            for (Object parameter : params) {
                octetses.add(MessageMgr.convertString2Octets((String)parameter.toString()));
            }
        }
        SPvP1BattleInfo snd = new SPvP1BattleInfo();
        snd.ismine = 0;
        snd.msgid = msgId;
        snd.parameters.addAll(octetses);
        Procedure.psendWhileCommit(broadcastSet, (Protocol)snd);
    }

    private void sendRaceBattleInfo(long roleId, int msgId, Object ... params) {
        if (msgId <= 0) {
            return;
        }
        LinkedList<Octets> octetses = new LinkedList<Octets>();
        if (params != null) {
            for (Object parameter : params) {
                octetses.add(MessageMgr.convertString2Octets((String)parameter.toString()));
            }
        }
        SPvP1BattleInfo snd = new SPvP1BattleInfo();
        snd.ismine = 1;
        snd.msgid = msgId;
        snd.parameters.addAll(octetses);
        Procedure.psendWhileCommit((long)roleId, (Protocol)snd);
    }

    private int getWinScore(int winLevel, int loseLevel) {
        PVPScoreAwardConfig config = PvPHelper.getScoreAwardConfig((int)winLevel);
        int addScore = config.win;
        int levelSub = Math.abs(loseLevel - winLevel);
        if (levelSub == 0) {
            return addScore;
        }
        PVPScoreAwardConfig subConfig = PvPHelper.getScoreAwardConfig((int)levelSub);
        if (subConfig == null) {
            return addScore;
        }
        addScore = winLevel > loseLevel ? (addScore += subConfig.adwin) : (addScore += subConfig.diswin);
        return addScore;
    }

    private int getLoseScore(int winLevel, int loseLevel) {
        PVPScoreAwardConfig config = PvPHelper.getScoreAwardConfig((int)loseLevel);
        int addScore = config.lose;
        int levelSub = Math.abs(loseLevel - winLevel);
        if (levelSub == 0) {
            return addScore;
        }
        PVPScoreAwardConfig subConfig = PvPHelper.getScoreAwardConfig((int)levelSub);
        if (subConfig == null) {
            return addScore;
        }
        addScore = loseLevel > winLevel ? (addScore += subConfig.adlose) : (addScore += subConfig.dislose);
        return addScore;
    }
}

